--------------------------------------
-------------Localization-------------
--------------------------------------
--local TravelBak = Travel;
local AAA = AzerothAdventureAlbum;
local L = AAA.L;
local Shelf = AAA.Shelf;
local Travel, Titans, TidesofV = AAA.Travel, AAA.Titans, AAA.TidesofV;

local rad, cos, sin, sqrt, max, min = math.rad, math.cos, math.sin, math.sqrt, math.max, math.min;

local filterChoice = nil;
local CurrentAlbum = Travel;

local FrameGap = 1/60;
local BlackscreenAlpha = 0.25;

local MENU_OPENSOUND  = SOUNDKIT.ACHIEVEMENT_MENU_OPEN;
local ReleaseDate = "April.19,2019";

local MainFrame, MinimapButton, AlbumSwitch, Blackscreen;
local lastbuttonNumber = lastbuttonNumber or 0 --avoid double-click
--------------------------------------
local function OpenNClosePanel()
	if (not AlbumSwitch:IsShown()) then
		MainFrame:ShowPanel();
	else
		MainFrame:HidePanel();
	end
end

SLASH_AAA1 = "/aaa"
SlashCmdList["AAA"] = function()
	OpenNClosePanel()
end
-------------------------------------
local sub_Num;

local function UpdateDropdownMenu(self, command)
	local FilterButtonList = {};
	FilterButtonList[1] = MainFrame.Filter.DropdownButton1;
	FilterButtonList[2] = MainFrame.Filter.DropdownButton2;
	FilterButtonList[3] = MainFrame.Filter.DropdownButton3;
	FilterButtonList[4] = MainFrame.Filter.DropdownButton4;
	FilterButtonList[5] = MainFrame.Filter.DropdownButton5;
	FilterButtonList[6] = MainFrame.Filter.DropdownButton6;
	FilterButtonList[7] = MainFrame.Filter.DropdownButton7;

	if (command == "clear") then
		FilterButtonList[1].ButtonName:SetTextColor(1,0.8,0);
		for i=2,#FilterButtonList,1 do
			FilterButtonList[i].ButtonName:SetTextColor(1,1,1);
		end
	else		
		for i=1, 7 do
			if (FilterButtonList[i] == self) then
				FilterButtonList[i].ButtonName:SetTextColor(1, 0.8, 0);
			else
				FilterButtonList[i].ButtonName:SetTextColor(1,1,1);
			end
		end
	end
end

local function CheckProgress(Album)
	local done = 0;
	for i = 1, #Album do
		if (Album[i]["Status"] == true) then
			done = done + 1;
		end
	end
	return done, #Album;
end

local function UpdateShelfProgressBar(self, button)
	local done, sum
	local buttonNumber = self.buttonNumber or button.buttonNumber;
	if (buttonNumber == 1) then
		done, sum = CheckProgress(Travel);
	elseif (buttonNumber == 2) then
		done, sum = CheckProgress(Titans);
	elseif (buttonNumber == 3) then
		done, sum = CheckProgress(TidesofV);
	elseif (buttonNumber == 4) then
		--CurrentAlbum = N/A;
	end
	done = done or 10;
	sum = sum or 10;
	local CurrentButton = self or button
	CurrentButton.StatusNum:SetText(done.."/"..sum)
	CurrentButton.StatusBar:SetWidth(182*done/sum);
end

local function GetTotalProgress()
	local a, _ = CheckProgress(Travel);
	local b, _ = CheckProgress(Titans);
	local c, _ = CheckProgress(TidesofV);
	local totals = #Travel + #Titans + #TidesofV;
	

	MainFrame.JournalBottomPanel.FilterButton.CurrentChoice:SetText(L["Total Cards"])
	MainFrame.JournalBottomPanel.FilterButton.CurrentProgress:SetText(a+b+c.."/"..totals)
end

local function ResetAlbum()
	UpdateDropdownMenu(_,"clear");
	
	MainFrame.selectedID = nil;
	sub_Num = nil;
	MainFrame.ListScrollFrame.scrollBar:SetValue(0);
	MainFrame.VirtualFrame.JournalDisplayTopLayer.Display:SetTexture("Interface/AddOns/AzerothAdventureAlbum/ART/Album/DefaultCover")
	MainFrame.VirtualFrame.JournalTestBackground:Hide();
	MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:Hide();
	MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:Hide();
	MainFrame.VirtualFrame.JournalPinButton:SetAlpha(0);
end

local function ShowShelf()
	PlaySound(SOUNDKIT.ACHIEVEMENT_MENU_OPEN);
	
	MainFrame.JournalBottomPanel.FilterButton:Disable();
	MainFrame.JournalBottomPanel.animIn:SetScript("OnPlay", function()
		GetTotalProgress();
	end);
	
	MainFrame.VirtualFrame.JournalDisplay.DisplayBottomLayer:Hide();
	MainFrame.VirtualFrame.JournalPinButton:Disable();

	local animationDuration = 0.3;

	local ag = MainFrame.ListScrollFrame:CreateAnimationGroup();
	local a1 = ag:CreateAnimation("Alpha");

	a1:SetFromAlpha(1);
	a1:SetDuration(animationDuration);
	a1:SetToAlpha(0);		
	ag:SetScript("OnFinished", function()
		MainFrame.ListScrollFrame:Hide()
	end);

	local ag2 = MainFrame.VirtualFrame:CreateAnimationGroup();
	local a2 = ag2:CreateAnimation("Alpha");

	a2:SetFromAlpha(1);
	a2:SetDuration(animationDuration);
	a2:SetToAlpha(0);		
	ag2:SetScript("OnFinished", function()
		MainFrame.VirtualFrame:Hide()
	end);

	ag:Play();
	ag2:Play();

	MainFrame.ListScrollFrame2:SetFrameStrata("HIGH");
	UIFrameFadeIn(MainFrame.ListScrollFrame2, animationDuration, 0, 1);
	MainFrame.JournalBottomPanel.animOut:Play();
	MainFrame.BackButton:Hide();
end

local function SetThumbTextureHeight()
	if(CurrentAlbum ~= nil) then
		MainFrame.ListScrollFrame.scrollBar.thumbTexture:SetHeight(Round(470*7/(#CurrentAlbum+1)))
	end
end

local Journal_UpdateList;
local function ChangeCurrentAlbum(self)
	if (self.buttonNumber == 1) then
		CurrentAlbum = Travel;	
	elseif (self.buttonNumber == 2) then
		CurrentAlbum = Titans;
	elseif (self.buttonNumber == 3) then
		CurrentAlbum = TidesofV;
	elseif (self.buttonNumber == 4) then
		
	end
	if (self.buttonNumber == 1) then
		MainFrame.JournalBottomPanel.FilterButton:Enable();
	else
		MainFrame.JournalBottomPanel.FilterButton:Disable();
	end
	Journal_UpdateList();
end

local function AAA_UpdateProgress()
	local sum_all, done_all, sum_sub, done_sub = 0, 0, 0, 0;
	
	sum_all = #CurrentAlbum;
	if (filterChoice == nil) then
		for i=1, #CurrentAlbum, 1 do
			if (CurrentAlbum[i]["Status"] == true) then
				done_all = done_all + 1;
			end
		end
		MainFrame.JournalBottomPanel.FilterButton.CurrentProgress:SetText(done_all.."/"..sum_all);
		return sum_all
	else
		for i=1, #CurrentAlbum, 1 do
			if (CurrentAlbum[i]["mapID"] == filterChoice) then
				sum_sub = sum_sub + 1;
				if (CurrentAlbum[i]["Status"] == true) then
					done_sub = done_sub +1;
				end
			elseif (filterChoice == 862 and CurrentAlbum[i]["mapID"] == 1165) then --Dazar'alor
				sum_sub = sum_sub + 1;
				if (CurrentAlbum[i]["Status"] == true) then
					done_sub = done_sub +1;
				end
			elseif (filterChoice == 895 and CurrentAlbum[i]["mapID"] == 1161) then --Boralus
				sum_sub = sum_sub + 1;
				if (CurrentAlbum[i]["Status"] == true) then
					done_sub = done_sub +1;
				end
			end
		end
		MainFrame.JournalBottomPanel.FilterButton.CurrentProgress:SetText(done_sub.."/"..sum_sub);
		return sum_sub
	end
end

local function AAA_EnableShelf()
	
	for i=1, (#MainFrame.ListScrollFrame2.buttons - 2) do
		MainFrame.ListScrollFrame2.buttons[i]:Enable()
	end
end

local function AAA_DisableShelf()
	
	for i=1, (#MainFrame.ListScrollFrame2.buttons -2) do
		MainFrame.ListScrollFrame2.buttons[i]:Disable()
	end
end

function AAAlbumBookCover_OnClick(self)
	MainFrame.Filter:Hide();
	MainFrame.Settings:Hide();
	
	AAA_DisableShelf();

	filterChoice = nil;
	MainFrame.selectedID = nil;
	lastbuttonNumber = 0;

	MainFrame.JournalBottomPanel.animIn:SetScript("OnPlay", function()
		AAA_UpdateProgress()
		MainFrame.JournalBottomPanel.FilterButton.CurrentChoice:SetText(L["BFA"]);
	end);

	ChangeCurrentAlbum(self);
	ResetAlbum();
	SetThumbTextureHeight()
	MainFrame.VirtualFrame.JournalDisplayTopLayer.Display:SetTexture(CurrentAlbum["DefaultCover"]);
	MainFrame.VirtualFrame.JournalPinButton:Enable();

	PlaySound(SOUNDKIT.ACHIEVEMENT_MENU_CLOSE);
	local animationDuration = 0.5
	

	local ag = MainFrame.ListScrollFrame2:CreateAnimationGroup();
	local a1 = ag:CreateAnimation("Alpha");

	a1:SetFromAlpha(1);
	a1:SetDuration(animationDuration);
	a1:SetToAlpha(0);	

	ag:SetScript("OnStop", function()
		AAA_EnableShelf();
	end);		
	ag:SetScript("OnFinished", function()
		MainFrame.ListScrollFrame2:SetFrameStrata("LOW");
		MainFrame.VirtualFrame.JournalDisplay.DisplayBottomLayer:Show();
		MainFrame.VirtualFrame:SetAlpha(1);
		C_Timer.After(0.6, function()
			AAA_EnableShelf();
		end)
	end);

	

	local ag2 = MainFrame.ListScrollFrame:CreateAnimationGroup();
	local a2 = ag2:CreateAnimation("Alpha");

	a2:SetFromAlpha(0);
	a2:SetDuration(animationDuration);
	a2:SetToAlpha(1);		
	ag2:SetScript("OnPlay", function()
		MainFrame.ListScrollFrame:Show()
	end);

	local ag3 = MainFrame.ListScrollFrame.ScrollChild:CreateAnimationGroup();
	local a3 = ag3:CreateAnimation("Translation");
	local offsetX = 100;
	a3:SetOrder(1);
	a3:SetOffset(0, offsetX);
	a3:SetDuration(0);

	local a4 = ag3:CreateAnimation("Translation");
	a4:SetOrder(2);
	a4:SetOffset(0, -offsetX);
	a4:SetSmoothing("OUT");
	a4:SetDuration(animationDuration);
	ag:Play();
	ag2:Play();
	ag3:Play();
	UIFrameFadeIn(MainFrame.VirtualFrame, animationDuration, 0, 1)
	MainFrame.JournalBottomPanel.animOut:Play();
	MainFrame.BackButton:Show();
end

local function CreateShelf(self, buttonTemplate, initialOffsetX, initialOffsetY, initialPoint, initialRelative, offsetX, offsetY, point, relativePoint)
	local scrollChild = self.scrollChild;
	local button, buttonWidth, buttonHeight, buttons, numButtons;

	local parentName = self:GetName();
	local buttonName = parentName and (parentName .. "Button") or nil;

	initialPoint = initialPoint or "TOPLEFT";
	initialRelative = initialRelative or "TOPLEFT";
	point = point or "TOPLEFT";
	relativePoint = relativePoint or "TOPRIGHT";
	offsetX = offsetX or 0;
	offsetY = offsetY or 0;

	if ( self.buttons ) then
		buttons = self.buttons;
		buttonWidth = buttons[1]:GetWidth();
		buttonHeight = buttons[1]:GetHeight();
	else
		button = CreateFrame("BUTTON", buttonName and (buttonName .. 1) or nil, scrollChild, buttonTemplate);
		buttonWidth = button:GetWidth();
		buttonHeight = button:GetHeight();
		button:SetPoint(initialPoint, scrollChild, initialRelative, initialOffsetX, initialOffsetY);
		buttons = {}
		tinsert(buttons, button);
	end

	self.buttonWidth = Round(buttonWidth) - offsetX;

	local numButtons = math.ceil(self:GetWidth() / buttonWidth) + 1;

	for i = #buttons + 1, numButtons do
		button = CreateFrame("BUTTON", buttonName and (buttonName .. i) or nil, scrollChild, buttonTemplate);
		button:SetPoint(point, buttons[i-1], relativePoint, offsetX, offsetY);
		tinsert(buttons, button);
	end

	scrollChild:SetHeight(self:GetHeight())
	scrollChild:SetWidth(numButtons * buttonWidth);
	self:SetVerticalScroll(0);
	self:UpdateScrollChildRect();

	self.buttons = buttons;
	local scrollBar = self.scrollBar;
	scrollBar:SetMinMaxValues(0, numButtons * buttonWidth)
	scrollBar.buttonWidth = buttonWidth;
	scrollBar.buttonHeight = buttonHeight;
	scrollBar:SetValueStep(buttonWidth);
	scrollBar:SetStepsPerPage(numButtons - 2);
	scrollBar:SetValue(0);

end
--------------------------------------
------------MinimapButton-------------
--------------------------------------
-- Derivative from [[LibDBIcon-1.0]]

local minimapShapes = {
	["ROUND"] = {true, true, true, true},
	["SQUARE"] = {false, false, false, false},
	["CORNER-TOPLEFT"] = {false, false, false, true},
	["CORNER-TOPRIGHT"] = {false, false, true, false},
	["CORNER-BOTTOMLEFT"] = {false, true, false, false},
	["CORNER-BOTTOMRIGHT"] = {true, false, false, false},
	["SIDE-LEFT"] = {false, true, false, true},
	["SIDE-RIGHT"] = {true, false, true, false},
	["SIDE-TOP"] = {false, false, true, true},
	["SIDE-BOTTOM"] = {true, true, false, false},
	["TRICORNER-TOPLEFT"] = {false, true, true, true},
	["TRICORNER-TOPRIGHT"] = {true, false, true, true},
	["TRICORNER-BOTTOMLEFT"] = {true, true, false, true},
	["TRICORNER-BOTTOMRIGHT"] = {true, true, true, false},
}

local function MinimapButton_UpdateAngle(radian)
	local x, y, q = cos(radian), sin(radian), 1;
	if x < 0 then q = q + 1 end
	if y > 0 then q = q + 2 end
	local minimapShape = GetMinimapShape and GetMinimapShape() or "ROUND"
	local quadTable = minimapShapes[minimapShape]
	local w = (Minimap:GetWidth() / 2) + 10
	local h = (Minimap:GetHeight() / 2) + 10
	if quadTable[q] then
		x, y = x*w, y*h
	else
		local diagRadiusW = sqrt(2*(w)^2) - 10	--  -10
		local diagRadiusH = sqrt(2*(h)^2) - 10
		x = max(-w, min(x*diagRadiusW, w))
		y = max(-h, min(y*diagRadiusH, h))
	end
	MinimapButton:SetPoint("CENTER", "Minimap", "CENTER", x, y)
end

local function MinimapButton_OnLoad()
	local radian = AAASettings["MinimapAngle"];
	MinimapButton_UpdateAngle(radian);
end

local function UpdateFrame_OnUpdate()
	local button = MinimapButton

	local mx, my = Minimap:GetCenter()
	local px, py = GetCursorPosition()
	local scale = Minimap:GetEffectiveScale()
	px, py = px / scale, py / scale
	local radian = math.atan2(py - my, px - mx);

	MinimapButton_UpdateAngle(radian);
	AAASettings["MinimapAngle"] = radian;
end


local function UpdateSettings()
	
	local Setting = MainFrame.Settings
	if (AAASettings["Minimap"]) then
		Setting.MiniButton.ButtonName:SetTextColor(0,1,0);
		Setting.MiniButton.ButtonName:SetText(L["Enabled"]);
	else
		Setting.MiniButton.ButtonName:SetTextColor(1,0,0);
		Setting.MiniButton.ButtonName:SetText(L["Disable"]);
	end

	if (AAASettings["Little Things"]) then
		Setting.LittleThingsButton.ButtonName:SetTextColor(0,1,0);
		Setting.LittleThingsButton.ButtonName:SetText(L["Enabled"]);
	else
		Setting.LittleThingsButton.ButtonName:SetTextColor(1,0,0);
		Setting.LittleThingsButton.ButtonName:SetText(L["Disable"]);
	end

	if (AAASettings["Darken Background"]) then
		Blackscreen.Black:SetColorTexture(0,0,0, BlackscreenAlpha);
		Setting.DarkenButton.ButtonName:SetTextColor(0,1,0);
		Setting.DarkenButton.ButtonName:SetText(L["Enabled"]);
	else
		Blackscreen.Black:SetColorTexture(0,0,0,0);
		Setting.DarkenButton.ButtonName:SetTextColor(1,0,0);
		Setting.DarkenButton.ButtonName:SetText(L["Disable"]);
	end

	if (AAASettings["Night Mode"]) then
		Setting.NightModeButton.ButtonName:SetTextColor(0,1,0);
		Setting.NightModeButton.ButtonName:SetText(L["Enabled"]);
	else
		Setting.NightModeButton.ButtonName:SetTextColor(1,0,0);
		Setting.NightModeButton.ButtonName:SetText(L["Disable"]);
	end

	if (AAASettings["Pin Style"] == 1) then
		MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin1");
		MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin1");
		Setting.PinStyleButton.ButtonName:SetText(L["Pin Paperclip"]);
	elseif (AAASettings["Pin Style"] == 2) then
		MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin2");
		MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin2");
		Setting.PinStyleButton.ButtonName:SetText(L["Pin Tape"]);
	elseif (AAASettings["Pin Style"] == 3) then
		MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin3");
		MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin3");
		Setting.PinStyleButton.ButtonName:SetText(L["Pin Staple"]);
	end

	if AAASettings["GlobalScale"] == 1 then
		Setting.ScaleButton.ButtonName:SetText(L["Scale Regular"]);
	else
		Setting.ScaleButton.ButtonName:SetText(L["Scale"]);
	end
end


function AAAlbumFilterButton_OnClick(self)
	PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
	UpdateDropdownMenu(self);
	local mapName = self.ButtonName:GetText();
	local temp = filterChoice;
	

	if 	   (mapName == L["Nazmir"]) then
		filterChoice = 863;
	elseif (mapName == L["Voldun"]) then
		filterChoice = 864;
	elseif (mapName == L["Zuldazar"]) then
		filterChoice = 862;
	elseif (mapName == L["Stormsong"]) then
		filterChoice = 942;
	elseif (mapName == L["Drustvar"]) then
		filterChoice = 896;
	elseif (mapName == L["Tiragarde"]) then
		filterChoice = 895;
	elseif (mapName == L["BFA"]) then
		filterChoice = nil;
	end
	MainFrame.JournalBottomPanel.FilterButton.CurrentChoice:SetText(self.ButtonName:GetText())
	
	sub_Num = AAA_UpdateProgress(filterChoice)

	if (filterChoice ~= temp) then
		MainFrame.ListScrollFrame.animOut:Play();
	end
end


--------------------------------------
---------------Settings---------------
--------------------------------------

function AAAlbum_VersionButton_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE",20, 0 );
	GameTooltip:SetText(L["AAA Gradient"]);
	GameTooltip:AddLine(" ", 1, 1, 1, true);
	GameTooltip:AddDoubleLine(L["Release Date"], ReleaseDate, nil, nil, nil, 1 , 1, 1);
	GameTooltip:AddDoubleLine(L["Author"], "Peterodox", nil, nil, nil, 1 , 1, 1);
	--GameTooltip:AddLine("\n"..L["Addon Explanation Line 1"], 1, 1, 1, true);
	--GameTooltip:AddLine("\n"..L["Addon Explanation Line 2"], 0.25, 0.78, 0.92, true);
	GameTooltip:SetPoint("BOTTOMLEFT",self,"BOTTOMRIGHT", 4, 0)
	GameTooltip:Show()
	self.showingTooltip = true;
end

function AAAlbum_DarkenSwitchButton_OnClick(self)
	AAASettings["Darken Background"] = not AAASettings["Darken Background"]

	if AAASettings["Darken Background"] == false then
		UIFrameFadeOut(Blackscreen, 0.5, Blackscreen:GetAlpha(), 0)
		self.ButtonName:SetTextColor(1,0,0);
		self.ButtonName:SetText(L["Disable"]);

		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF);

	elseif AAASettings["Darken Background"] == true then

		Blackscreen.Black:SetColorTexture(0,0,0,BlackscreenAlpha)
		UIFrameFadeIn(Blackscreen, 1, 0, 1)

		self.ButtonName:SetTextColor(0,1,0);
		self.ButtonName:SetText(L["Enabled"])

		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
	end
end

function AAAlbum_DarkenSwitchButton_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE",20, 0 );
	GameTooltip:SetText(L["Darken Background"]);
	GameTooltip:AddLine(L["DarkenButton Explanation Line 1"], 1, 1, 1, true);
	GameTooltip:SetPoint("BOTTOMLEFT",self,"BOTTOMRIGHT", 4, 0)
	GameTooltip:Show()
	self.showingTooltip = true;
end

function AAAlbum_PinStyleButton_OnClick(self)
	
	if (not MainFrame.VirtualFrame.JournalTestBackground:IsShown()) then
		MainFrame.VirtualFrame.JournalTestBackground.animOut:Stop();
		MainFrame.VirtualFrame.JournalTestBackground:Show();
		MainFrame.VirtualFrame.JournalTestBackground.animIn:Play();
	end
	MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:Hide();
	MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:Show();
	MainFrame.VirtualFrame.JournalPinButton:SetAlpha(1);

	if (AAASettings["Pin Style"] ~= nil and AAASettings["Pin Style"] == 1) then
		AAASettings["Pin Style"] = 2;
		MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin2")
		MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin2")
		self.ButtonName:SetText(L["Pin Tape"]);
	elseif (AAASettings["Pin Style"] == 2) then
		AAASettings["Pin Style"] = 3;
		MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin3")
		MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin3")
		self.ButtonName:SetText(L["Pin Staple"]);
	elseif (AAASettings["Pin Style"] == 3) then
		AAASettings["Pin Style"] = 1;
		MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin1")
		MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin1")
		self.ButtonName:SetText(L["Pin Paperclip"]);
	else
		AAASettings["Pin Style"] = 1;
		MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin1")
		MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:SetTexture("Interface\\AddOns\\AzerothAdventureAlbum\\ART\\Card\\Pin1")
		self.ButtonName:SetText(L["Pin Paperclip"]);
	end
	PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
end

function AAAlbum_PinStyleButton_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE",20, 0 );
	GameTooltip:SetText(L["Pin Style"]);
	GameTooltip:AddLine(L["PinStyleButton Explanation Line 1"], 1, 1, 1, true);
	GameTooltip:AddLine("\n"..L["PinStyleButton Explanation Line 2"], nil, nil, nil, true);
	GameTooltip:AddLine(L["Pin Paperclip"]..", "..L["Pin Tape"]..", "..L["Pin Staple"], 1, 1, 1, true);
	GameTooltip:SetPoint("BOTTOMLEFT",self,"BOTTOMRIGHT", 4, 0)
	GameTooltip:Show()
	self.showingTooltip = true;	
end

function AAAlbum_ScaleButton_OnClick(self)
	local scale = AAASettings["GlobalScale"];
	if scale == 1 then
		AAASettings["GlobalScale"] = 0.8;
		self.ButtonName:SetText(L["Scale"]);
	else
		AAASettings["GlobalScale"] = 1;
		self.ButtonName:SetText(L["Scale Regular"]);
	end

	GlobalScale = AAASettings["GlobalScale"];
	MainFrame:SetScale(GlobalScale);
	NightMode:SetScale(GlobalScale);
end

function AAAlbum_ScaleButton_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE",20, 0 );
	GameTooltip:SetText(L["Scale"]);
	GameTooltip:AddLine(L["ScaleButton Explanation Line 1"], 1, 1, 1, true);
	--GameTooltip:AddLine("\n"..L["ScaleButton Explanation Line 2"], nil, nil, nil, true);
	GameTooltip:SetPoint("BOTTOMLEFT",self,"BOTTOMRIGHT", 4, 0)
	GameTooltip:Show()
end

function AAAlbum_LittleThingsButton_OnClick(self)
	AAASettings["Little Things"]= not AAASettings["Little Things"];
	if (AAASettings["Little Things"] == false) then
		self.ButtonName:SetText(L["Disable"]);
		self.ButtonName:SetTextColor(1,0,0);
		if SnowContainer:IsShown() then
			SnowEffect(false)
		end
		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF);
	elseif (AAASettings["Little Things"] == true) then
		self.ButtonName:SetText(L["Enabled"])
		self.ButtonName:SetTextColor(0,1,0);
		SnowEffect(true)
		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
	end
end

function AAAlbum_LittleThingsButton_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE",20, 0 );
	GameTooltip:SetText(L["Little Things"]);
	GameTooltip:AddLine(L["LittleThingsButton Explanation Line 1"], 1, 1, 1, true);
	GameTooltip:AddLine("\n"..L["LittleThingsButton Explanation Line 2"], nil, nil, nil, true);
	GameTooltip:SetPoint("BOTTOMLEFT",self,"BOTTOMRIGHT", 4, 0)
	GameTooltip:Show()
	self.showingTooltip = true;
end

function AAAlbum_MiniButton_OnClick(self)
	AAASettings["Minimap"] = not AAASettings["Minimap"];
	if (AAASettings["Minimap"] == false) then
		self.ButtonName:SetText(L["Disable"]);
		self.ButtonName:SetTextColor(1,0,0);

		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF);
	elseif (AAASettings["Minimap"] == true) then
		self.ButtonName:SetText(L["Enabled"])
		self.ButtonName:SetTextColor(0,1,0);

		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
	end

	MinimapButton:UpdateVisibility();
end

function AAAlbum_MiniButton_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE",20, 0 );
	GameTooltip:SetText(L["Mini Button"]);
	GameTooltip:AddLine(L["MinimapButton Explanation Line 1"], 1, 1, 1, true);
	GameTooltip:SetPoint("BOTTOMLEFT",self,"BOTTOMRIGHT", 4, 0)
	GameTooltip:Show()
	self.showingTooltip = true;
end

function AAAlbum_NightModeButton_OnClick(self)
	AAASettings["Night Mode"] = not AAASettings["Night Mode"]

	if (AAASettings["Night Mode"] == false) then
		self.ButtonName:SetText(L["Disable"]);
		self.ButtonName:SetTextColor(1,0,0);
		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF);

		if NightMode:IsShown() then
			NightMode:Hide()
		end

	elseif (AAASettings["Night Mode"] == true) then
		self.ButtonName:SetText(L["Enabled"])
		self.ButtonName:SetTextColor(0,1,0);
		PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON);
		SetNightModeAlpha()
		NightMode:Show()
	end
end

function AAAlbum_NightModeButton_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE",20, 0 );
	GameTooltip:SetText(L["Night Mode"]);
	GameTooltip:AddLine(L["NightMode Explanation Line 1"], 1, 1, 1, true);
	GameTooltip:AddLine("\n"..L["NightMode Explanation Line 2"], nil, nil, nil, true);
	GameTooltip:AddLine("\n"..L["NightMode Explanation Special"], 0.25, 0.78, 0.92, true);  --Special Notification /RGB: Light Blue
	GameTooltip:SetPoint("BOTTOMLEFT",self,"BOTTOMRIGHT", 4, 0)
	GameTooltip:Show()
	self.showingTooltip = true;
end

local function UpdateMinimapSettings()
	if (AAASettings["Minimap"]) then
		MainFrame.Settings.MiniButton.ButtonName:SetTextColor(0,1,0);
		MainFrame.Settings.MiniButton.ButtonName:SetText(L["Enabled"]);
	else
		MainFrame.Settings.MiniButton.ButtonName:SetTextColor(1,0,0);
		MainFrame.Settings.MiniButton.ButtonName:SetText(L["Disable"]);
	end
end


--------------------------------------
------------Classification------------
--------------------------------------
local function BuildSubList(filterChoice, list)
	local SubList = {};
	local j = 1;
	if (filterChoice == nil) then
		SubList = list
		for i=1, #list, 1 do
			list[i]["RealNumber"] = i;
			SubList[i]["RealNumber"] = i;
		end
		return SubList
	else
		for i=1,#list,1 do
			if (list[i]["mapID"] == filterChoice) then
				SubList[j] = list[i];
				SubList[j]["RealNumber"] = i;
				j = j + 1;
			elseif (filterChoice == 862 and list[i]["mapID"] == 1165) then
				SubList[j] = list[i];
				SubList[j]["RealNumber"] = i;
				j = j + 1;
			elseif (filterChoice == 895 and list[i]["mapID"] == 1161) then
				SubList[j] = list[i];
				SubList[j]["RealNumber"] = i;
				j = j + 1;
			end	
		end
		return SubList
	end
end

local function PlayShelfScrollAnimation()
	
	for i=1, #MainFrame.ListScrollFrame2.buttons do
		--MainFrame.ListScrollFrame2.buttons[i].FakeScroll.animIn:Play();
		MainFrame.ListScrollFrame2.buttons[i].Scroll:SetTexCoord(0, 0.1416015625, 0, 0.283203125)
		MainFrame.ListScrollFrame2.buttons[i].DescriptionClipper:SetClipsChildren(true)
		MainFrame.ListScrollFrame2.buttons[i].DescriptionClipper:SetHeight(0)
		MainFrame.ListScrollFrame2.buttons[i].VirtualSwitch.animIn:Play();
	end
end

local function UpdatePaperHeight()
	local textHeight_Lore = 56 + Round(MainFrame.VirtualFrame.JournalTestBackground.Lore:GetHeight());
	MainFrame.VirtualFrame.JournalTestBackground.LoreBackground:SetHeight(textHeight_Lore);
end

function AAAlbum_JournalDisplay_OnEnter()
	if (MainFrame.selectedID ~= nil and (not MainFrame.VirtualFrame.JournalTestBackground:IsShown()) ) then
		MainFrame.VirtualFrame.JournalTestBackground.animOut:Stop();
		MainFrame.VirtualFrame.JournalTestBackground:Show();
		MainFrame.VirtualFrame.JournalTestBackground.animIn:Play();
	end
end

function AAAlbum_JournalDisplay_OnLeave()
	
	if (MainFrame.selectedID ~= nil and (not MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:IsShown()) ) then
		MainFrame.VirtualFrame.JournalTestBackground.animIn:Stop();
		MainFrame.VirtualFrame.JournalTestBackground.animOut:Play();
	end
end

--Derivative from Blizzard: HybridScrollFrame_CreateButtons
local function CreateEntryButtons(self, buttonTemplate, initialOffsetX, initialOffsetY, initialPoint, initialRelative, offsetX, offsetY, point, relativePoint)
	local scrollChild = self.scrollChild;
	local button, buttonHeight, buttons, numButtons;

	local parentName = self:GetName();
	local buttonName = parentName and (parentName .. "Button") or nil;

	initialPoint = initialPoint or "TOPLEFT";
	initialRelative = initialRelative or "TOPLEFT";
	point = point or "TOPLEFT";
	relativePoint = relativePoint or "BOTTOMLEFT";
	offsetX = offsetX or 0;
	offsetY = offsetY or 0;

	if ( self.buttons ) then
		buttons = self.buttons;
		buttonHeight = buttons[1]:GetHeight();
	else
		button = CreateFrame("BUTTON", buttonName and (buttonName .. 1) or nil, scrollChild, buttonTemplate);
		buttonHeight = button:GetHeight();
		button:SetPoint(initialPoint, scrollChild, initialRelative, initialOffsetX, initialOffsetY);
		buttons = {}
		tinsert(buttons, button);
	end

	self.buttonHeight = Round(buttonHeight) - offsetY;

	local numButtons = math.ceil(self:GetHeight() / buttonHeight) + 1;

	for i = #buttons + 1, numButtons do
		button = CreateFrame("BUTTON", buttonName and (buttonName .. i) or nil, scrollChild, buttonTemplate);
		button:SetPoint(point, buttons[i-1], relativePoint, offsetX, offsetY);
		tinsert(buttons, button);
	end

	scrollChild:SetWidth(self:GetWidth())
	scrollChild:SetHeight(numButtons * buttonHeight);
	self:SetVerticalScroll(0);
	self:UpdateScrollChildRect();

	self.buttons = buttons;
	local scrollBar = self.scrollBar;
	scrollBar:SetMinMaxValues(0, numButtons * buttonHeight)
	scrollBar.buttonHeight = buttonHeight;
	scrollBar:SetValueStep(buttonHeight);
	scrollBar:SetStepsPerPage(numButtons - 2);
	scrollBar:SetValue(0);

end

local function UpdateScrollFrame(self, totalHeight, displayedHeight)
	local range = floor(totalHeight - self:GetHeight() + 0.5);
	if ( range > 0 and self.scrollBar ) then
		local minVal, maxVal = self.scrollBar:GetMinMaxValues();
		if ( math.floor(self.scrollBar:GetValue()) >= math.floor(maxVal) ) then
			self.scrollBar:SetMinMaxValues(0, range)
			if ( math.floor(self.scrollBar:GetValue()) ~= math.floor(range) ) then
				self.scrollBar:SetValue(range);
			else
				HybridScrollFrame_SetOffset(self, range);
			end
		else
			self.scrollBar:SetMinMaxValues(0, range)
		end
		self.scrollBar:Enable();
		HybridScrollFrame_UpdateButtonStates(self);
		self.scrollBar:Show();
	elseif ( self.scrollBar ) then
		self.scrollBar:SetValue(0);
		if ( self.scrollBar.doNotHide ) then
			self.scrollBar:Disable();
			self.scrollUp:Disable();
			self.scrollDown:Disable();
			self.scrollBar.thumbTexture:Hide();
		else
			self.scrollBar:Hide();
		end
	end

	self.range = range;
	self.totalHeight = totalHeight;
	self.scrollChild:SetHeight(displayedHeight);
	self:UpdateScrollChildRect();
end

local function HybridScrollFrame_SetOffset_Horizontal(self, offset)
	local buttons = self.buttons
	local buttonWidth = self.buttonWidth;
	local element, overflow;

	local scrollWidth = 0;

	local largeButtonTop = self.largeButtonTop
	if ( self.dynamic ) then --This is for frames where buttons will have different heights
		if ( offset < buttonWidth ) then
			-- a little optimization
			element = 0;
			scrollWidth = offset;
		else
			element, scrollWidth = self.dynamic(offset);
		end
	elseif ( largeButtonTop and offset >= largeButtonTop ) then
		local largeButtonWidth = self.largeButtonWidth;
		-- Initial offset...
		element = largeButtonTop / buttonWidth;

		if ( offset >= (largeButtonTop + largeButtonWidth) ) then
			element = element + 1;

			local leftovers = (offset - (largeButtonTop + largeButtonWidth) );

			element = element + ( leftovers / buttonWidth );
			overflow = element - math.floor(element);
			scrollWidth = overflow * buttonWidth;
		else
			scrollWidth = math.abs(offset - largeButtonTop);
		end
	else
		element = offset / buttonWidth;
		overflow = element - math.floor(element);
		scrollWidth = overflow * buttonWidth;
	end

	if ( math.floor(self.offset or 0) ~= math.floor(element) and self.update ) then
		self.offset = element;
		self:update();
	else
		self.offset = element;
	end

	self:SetHorizontalScroll(scrollWidth);
end

local function HybridScrollFrame_Update_Horizontal(self, totalWidth, displayedWidth)
	--self.buttonHeight=0.01
	local range = floor(totalWidth - self:GetWidth() + 0.5);
	if ( range > 0 and self.scrollBar ) then
		local minVal, maxVal = self.scrollBar:GetMinMaxValues();
		if ( math.floor(self.scrollBar:GetValue()) >= math.floor(maxVal) ) then
			self.scrollBar:SetMinMaxValues(0, range)
			if ( math.floor(self.scrollBar:GetValue()) ~= math.floor(range) ) then
				self.scrollBar:SetValue(range);
			else
				HybridScrollFrame_SetOffset_Horizontal(self, range);
			end
		else
			self.scrollBar:SetMinMaxValues(0, range)
		end
		self.scrollBar:Enable();
		HybridScrollFrame_UpdateButtonStates(self);
		self.scrollBar:Show();
	elseif ( self.scrollBar ) then
		self.scrollBar:SetValue(0);
		if ( self.scrollBar.doNotHide ) then
			self.scrollBar:Disable();
			self.scrollUp:Disable();
			self.scrollDown:Disable();
			self.scrollBar.thumbTexture:Hide();
		else
			self.scrollBar:Hide();
		end
	end

	self.range = range;
	self.totalWidth = totalWidth;
	self.scrollChild:SetWidth(displayedWidth);
	self:UpdateScrollChildRect();
end

local function HybridScrollFrame_OnValueChangedT(self, value)
	HybridScrollFrame_SetOffset(self:GetParent(), value);
	HybridScrollFrame_UpdateButtonStates(self:GetParent(), value);
end

local function HybridScrollFrame_OnValueChanged_Horizontal(self, value)
	HybridScrollFrame_SetOffset_Horizontal(self:GetParent(), value);
	HybridScrollFrame_UpdateButtonStates(self:GetParent(), value);
	
	if (MainFrame.ListScrollFrame2.scrollBar.UpButton:IsEnabled()) then
		UIFrameFadeIn(MainFrame.ListScrollFrame2.scrollBar.LeftOverlay,0.15,0,1);
	else
		UIFrameFadeOut(MainFrame.ListScrollFrame2.scrollBar.LeftOverlay,0.15,1,0);
	end
	if (MainFrame.ListScrollFrame2.scrollBar.DownButton:IsEnabled()) then
		UIFrameFadeIn(MainFrame.ListScrollFrame2.scrollBar.RightOverlay,0.15,0,1);
	else
		UIFrameFadeOut(MainFrame.ListScrollFrame2.scrollBar.RightOverlay,0.15,1,0);
	end
end

--------------------------------------------------------------------
function AAAlbum_PinButton_OnEnter(self)
	
	if MainFrame.VirtualFrame.JournalTestBackground:IsShown() then
		GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT",0,-10);
		if (MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:IsShown() ) then
			GameTooltip:SetText(L["Disable Pin"]);
		else
			GameTooltip:SetText(L["Enable Pin"]);
			if (not MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:IsShown() ) then
				MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:Show();
			end
		end
		self.showingTooltip = true;
	end
end

function AAAlbum_ReturnButton_OnClick(self)
	
	MainFrame.Filter:Hide();
	MainFrame.Settings:Hide();
	ShowShelf();
end

function AAAlbum_ReturnButton_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT",0,15);
	GameTooltip:SetText(L["Return"] );
	self.showingTooltip = true;
	--MainFrame.VirtualButton:Disable();
end

function AAAlbum_PinButton_OnClick(self)
	PlaySound(SOUNDKIT.UI_TRANSMOG_GEAR_SLOT_CLICK);
	
	if (not MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:IsShown() ) then
		MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:Show();
		MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:Hide();
	else
		MainFrame.VirtualFrame.JournalPinButton.PinButtonDown:Hide();
		MainFrame.VirtualFrame.JournalPinButton.PinButtonUp:Show();
	end
	AAAlbum_PinButton_OnEnter(self);
end


local animationDone = true;
local function ShelfFrame_OnMouseWheel(self, delta, stepSize)
	if ( not self.scrollBar:IsVisible() ) then
		return;
	end

	local minVal, maxVal = 0, self.range;
	local stepSize = stepSize or self.stepSize or self.buttonWidth;
	local Current = self.scrollBar:GetValue();
	self.scrollBar:SetValueStep(0.01);

	----------------------------------------	
	---Smoothing Animation for ScrollList---
	----------------------------------------
	local ag = MainFrame.ListScrollFrame2.ScrollChild.animTranlation;
	if not ag then
		ag = MainFrame.ListScrollFrame2.ScrollChild:CreateAnimationGroup();
		MainFrame.ListScrollFrame2.ScrollChild.animTranlation = ag;
		ag.a1 = ag:CreateAnimation("Translation");
		ag.a1:SetDuration(0.3);
		ag.a1:SetSmoothing("OUT");
	end
	local a1 = ag.a1;
	if (animationDone) then
		if ( delta == 1 ) then
			a1:SetOffset(-(-self.scrollBar:GetValue() + max(minVal, self.scrollBar:GetValue() - stepSize)),0); 
		else
			a1:SetOffset(-(-self.scrollBar:GetValue() + min(maxVal, self.scrollBar:GetValue() + stepSize)),0);
		end
		
		ag:SetScript("OnFinished", function()
			if ( delta == 1 ) then
				self.scrollBar:SetValue(max(minVal, self.scrollBar:GetValue() - stepSize));
			else
				self.scrollBar:SetValue(min(maxVal, self.scrollBar:GetValue() + stepSize));
			end
				animationDone = true;
			end)

			ag:SetScript("OnPlay", function()
				animationDone = false;
			end)
		ag:Play();
	end
end

----------------------------------------	
---Smoothing Animation for ScrollList---
----------------------------------------
local SmoothScrollFactors = {};
SmoothScrollFactors.minVal = 0;
SmoothScrollFactors.maxVal = 0;
SmoothScrollFactors.stepSize = 0;
SmoothScrollFactors.delta = 0;
SmoothScrollFactors.animationDuration = 0;
SmoothScrollFactors.endValue = 0;

local SmoothScrollContainer = CreateFrame("Frame");
SmoothScrollContainer:SetScript("OnShow", function()
	SmoothScrollFactors.endValue = MainFrame.ListScrollFrame.scrollBar:GetValue()
end);

SmoothScrollContainer:Hide();

SmoothScrollContainer:SetScript("OnUpdate", function(self, elapsed)
	
	local delta = SmoothScrollFactors.delta;
	local scrollBar = MainFrame.ListScrollFrame.scrollBar
	local speed = math.abs(scrollBar:GetValue() - SmoothScrollFactors.endValue)/5;

	if ( delta == 1 ) then
		scrollBar:SetValue(max(0, scrollBar:GetValue() - speed));
	else
		scrollBar:SetValue(min(SmoothScrollFactors.maxVal, scrollBar:GetValue() + speed));
	end

	if SmoothScrollFactors.animationDuration >= 2 or speed<= 0.25 then
		--print(SmoothScrollFactors.animationDuration)
		--SmoothScrollFactors.animationDuration = 0;
		scrollBar:SetValue(min(SmoothScrollFactors.maxVal, SmoothScrollFactors.endValue));
		SmoothScrollContainer:Hide();
	end
end);

local function SmoothScroll_OnMouseWheel(self, delta, stepSize)
	if ( not self.scrollBar:IsVisible() ) then
		return;
	end
	--SmoothScrollFactors.animationDuration = 0;
	SmoothScrollFactors.maxVal = self.range;
	
	local stepSize = stepSize or self.stepSize or self.buttonHeight;
	SmoothScrollFactors.stepSize = stepSize;
	local Current = self.scrollBar:GetValue();
	self.scrollBar:SetValueStep(0.01);
	SmoothScrollFactors.delta = delta;

	--print(SmoothScrollFactors.delta.." Range= "..SmoothScrollFactors.maxVal.." StepSize= "..SmoothScrollFactors.stepSize)
	if not((Current == 0 and delta > 0) or (Current == self.range and delta < 0 )) then
		SmoothScrollContainer:Show()
	end
	SmoothScrollFactors.endValue = min(max(0, SmoothScrollFactors.endValue - delta*SmoothScrollFactors.stepSize), SmoothScrollFactors.maxVal)
end
----------------------------------------

local function Journal_OnLoad(self)
	self.ListScrollFrame.scrollBar:Hide();
	self.ListScrollFrame.update = Journal_UpdateList;
	CreateEntryButtons(self.ListScrollFrame, "AAAlbumEntryButtonTemplate", 20, 0, nil, nil, 0, 0);
	MainFrame.selectedID = nil;
	self.ListScrollFrame.scrollBar.thumbTexture:SetHeight(Round(470*7/30))
	CreateShelf(self.ListScrollFrame2, "AAAlbumBookCoverTemplate", 0, 0, nil, nil, 0, 0);

	self:SetScale(0.0001)
	MainFrame.JournalBottomPanel.FilterButton:Disable();
end

--Private
function Journal_UpdateList()
	local scrollFrame = MainFrame.ListScrollFrame;
	
	SetThumbTextureHeight();
	if (sub_Num~=nil and sub_Num > 7) then --change the thumb texture height when using the map filter
		MainFrame.ListScrollFrame.scrollBar.thumbTexture:SetHeight(470*7/sub_Num);
	elseif (sub_Num~=nil and sub_Num == 7) then
		MainFrame.ListScrollFrame.scrollBar.thumbTexture:SetHeight(470*7/9);
	end
	
	local offset = HybridScrollFrame_GetOffset(scrollFrame);
	local buttons = scrollFrame.buttons;

	CurrentAlbum = CurrentAlbum or Travel;
	TravelSub = BuildSubList(filterChoice, CurrentAlbum);

	local numList = #TravelSub;
	for i=1, #buttons do
		local button = buttons[i];
		local displayIndex = i + offset;
		if ( displayIndex <= numList ) then
			local index = displayIndex;
			button.Title:SetText("Test Title"..displayIndex);
			button.Description:SetText("Test Description"..displayIndex);
			button.icon:SetTexture(133975 + displayIndex)
			button.active = active;
			button.entryID = (TravelSub[displayIndex]["RealNumber"]);
			if(TravelSub[displayIndex]["RealNumber"] == MainFrame.selectedID) then
				button.selectedTexture:Show();
			else
				button.selectedTexture:Hide();	
			end

			if( TravelSub[displayIndex] ~= nil ) then
				
				button.Title:SetText(TravelSub[displayIndex]["Title"]);
				button.Description:SetText(TravelSub[displayIndex]["Description"]);
				button.icon:SetTexture(TravelSub[displayIndex]["Icon"]);
				if (TravelSub[displayIndex]["Status"]) then
					button.Background:SetDesaturated(false);
					button.icon:SetDesaturated(false);
					button.ButtonHighlight:SetDesaturated(false);
					button.Overlay:SetDesaturated(false);
					button.Title:SetTextColor(1,0.8,0)
				else
					button.Background:SetDesaturated(true);
					button.icon:SetDesaturated(true);
					button.ButtonHighlight:SetDesaturated(true);
					button.Overlay:SetDesaturated(true);
					button.Title:SetTextColor(1,1,1);
				end
			else
				button.Title:SetTextColor(1,1,1);
				button.Title:SetText("Test Title");
				button.Description:SetText("This is a description.");
				button.icon:SetTexture(236452);
				button.Background:SetDesaturated(true);
				button.icon:SetDesaturated(true);
				button.ButtonHighlight:SetDesaturated(true);
				button.Overlay:SetDesaturated(true);
			end

			button:Show();
			button:SetEnabled(true);
		else
			button:Hide();
			button:SetEnabled(false);
		end
	end
	local totalHeight = numList * buttons[1]:GetHeight();
	UpdateScrollFrame(scrollFrame, totalHeight, scrollFrame:GetHeight());
end

local function UpdateAllProgressBars()
	
	local scrollFrame = MainFrame.ListScrollFrame2;
	local buttons = scrollFrame.buttons;
	for i=1, #buttons do
		UpdateShelfProgressBar(buttons[i]);
	end
end





--------------------------------------
--------------Animations--------------
--------------------------------------

local AnimsequenceInfo = {
	["Scroll"] = {
		 ["TotalFrames"] = 21,
		 ["cX"] = 0.1416015625,
		 ["cY"] = 0.283203125,
		 ["Column"] = 7,
		 ["Row"] = 3	
	},

	["BookCover"] = {
		["TotalFrames"] = 22,
		["cX"] = 0.14453125,
		["cY"] =  0.1826171875,
		["Column"] = 6,
		["Row"] = 5	
   },

}

local function InitializeAnimationContainer(frame, sequenceInfo, targetFrame)
	frame.OppoDirection = false;
	frame.t = 0
	frame.index = 1;
	frame.total = 0;
	frame.Pending = false;
	frame.isPlaying = false;	
	frame.sequenceInfo = sequenceInfo;
	frame.target = targetFrame;
end

local function ScrollAnimation_OnHide(self)
	self.isPlaying = false;
	self.t = 0;
	self.index = 0;
end

local function AAAPlayAnimationSequence(index, sequenceInfo, texture, direct)
	local texture = texture or PhotoModeControllerTransition.Sequence;
	local sequenceInfo = sequenceInfo or AnimsequenceInfo["Controller"];
	local Frames = sequenceInfo["TotalFrames"];
	local cX, cY = sequenceInfo["cX"], sequenceInfo["cY"];
	local Column, Row = sequenceInfo["Column"], sequenceInfo["Row"]

	if (index > Frames and not direct) or (index < 1 and direct) then
		return false;
	end

	local n = math.modf((index -1)/ Row) + 1;
	local m = index % Row
	if m == 0 then
		m = Row;
	end

	local left, right = (n-1)*cX, n*cX;
	local top, bottom = (m-1)*cY, m*cY;
	texture:SetTexCoord(left, right, top, bottom);
	
	texture:SetAlpha(1)
	return true;
end

local ASC1 = CreateFrame("Frame","AnimationSequenceContainer_ScrollDown");
ASC1:Hide();

local function UpdateDescriptionClipper(self, index)
	self:GetParent().DescriptionClipper:SetHeight((index-4)*10)
end

function AAAlbum_AnimationSequence_SingleDirection_OnUpdate(self, elapsed)
	if self.Pending then
		return;
	end

	self.t = self.t + elapsed;

	if self.t >= FrameGap then
		self.t = 0;
		self.index = self.index + 1;
		UpdateDescriptionClipper(self,self.index)
		if not AAAPlayAnimationSequence(self.index, self.sequenceInfo, self.target, false) then
			self:Hide()
			self:GetParent().DescriptionClipper:SetClipsChildren(false)
		end
	end
end

function AAAlbum_AnimationSequence_Loop_OnUpdate(self, elapsed)
	if self.Pending then
		return;
	end

	self.t = self.t + elapsed;
	
	if self.t >= FrameGap then
		self.t = 0;
		if self.OppoDirection then
			self.index = self.index - 1;
		else
			self.index = self.index + 1;
		end

		if not AAAPlayAnimationSequence(self.index, self.sequenceInfo, self.target, self.OppoDirection) then
			self:Hide()
			return;
		end
	end

	--print(self.t)
end

ASC1:SetScript("OnUpdate", AAAlbum_AnimationSequence_SingleDirection_OnUpdate)
ASC1:SetScript("OnHide", ScrollAnimation_OnHide)
ASC1:SetScript("OnShow", function(self)
	self.isPlaying = true;
end)



-----------------------------------------------------------------
local function CreateOpeningAnimation()
	--Show
	local animationDuration = 0.25;
	local animShow = MainFrame:CreateAnimationGroup();
	local a1 = animShow:CreateAnimation("Alpha");

	a1:SetFromAlpha(0);
	a1:SetDuration(animationDuration);
	a1:SetToAlpha(1);	

	animShow:SetScript("OnPlay", function()
		MainFrame:Show()
		PlayShelfScrollAnimation()
		MainFrame.ListScrollFrame2:Show()
		MainFrame:SetScale(AAASettings["GlobalScale"])
	end);
	animShow:SetScript("OnFinished", function()
		MainFrame.VirtualFrame.JournalDisplay.DisplayBottomLayer:Show();
		UpdateAllProgressBars();
	end);
	MainFrame.animShow = animShow;

	--Hide
	local animationDuration = 0.25;
	local animHide = MainFrame:CreateAnimationGroup();
	local a1 = animHide:CreateAnimation("Translation");
	local a2 = animHide:CreateAnimation("Alpha");

	a1:SetOffset(0,-30); 
	a1:SetDuration(animationDuration);
	a1:SetSmoothing("IN");

	a2:SetFromAlpha(1);
	a2:SetStartDelay(0.1)
	a2:SetDuration(animationDuration);
	a2:SetToAlpha(0);	

	animHide:SetScript("OnPlay", function()
		MainFrame.VirtualFrame.JournalDisplay.DisplayBottomLayer:Hide();
	end);

	animHide:SetScript("OnFinished", function()
		--DoEmote("Read", "none")
		MainFrame:SetScale(0.0001)
		MainFrame.Filter:Hide(); --self:GetParent():Hide();
		MainFrame.Settings:Hide();
	end);
	MainFrame.animHide = animHide;
end


AAAlbumMainFrameMixin = {};

function AAAlbumMainFrameMixin:OnLoad()
	MainFrame = self;
	self:RegisterForDrag("LeftButton");
	CreateOpeningAnimation();
	Journal_OnLoad(self);


	self.ListScrollFrame:SetScript("OnMouseWheel", SmoothScroll_OnMouseWheel);
	self.ListScrollFrame.scrollBar:SetScript("OnValueChanged", HybridScrollFrame_OnValueChangedT);
	self.ListScrollFrame2:SetScript("OnMouseWheel", ShelfFrame_OnMouseWheel);
	self.ListScrollFrame2.scrollBar:SetScript("OnValueChanged", HybridScrollFrame_OnValueChanged_Horizontal);

	self.VirtualFrame.JournalTestBackground.LocationHeader:SetText(L["Location"]);
	self.VirtualFrame.JournalTestBackground.LoreHeader:SetText(L["Lore"]);
end

function AAAlbumMainFrameMixin:OnEnter()
	if not (self.ListScrollFrame:IsMouseOver() or self.ListScrollFrame2:IsMouseOver() ) then
		SetCursor("Interface/CURSOR/UI-Cursor-Move.blp");
	end
end

function AAAlbumMainFrameMixin:ShowPanel()
	AlbumSwitch:Show();
	self.animShow:Play();
end

function AAAlbumMainFrameMixin:HidePanel()
	AlbumSwitch:Hide();
	self.animHide:Play();
end

function AAAlbumMainFrameMixin:ResetPosition()
	self:ClearAllPoints();
	self:SetPoint("CENTER", UIParent, "CENTER", 0 ,0);
	self:SetUserPlaced(false);
end

function AAAlbumMainFrameMixin:UpdateList()
	Journal_UpdateList();
end

function AAAlbumMainFrameMixin:UpdateShelf()
	local scrollFrame = MainFrame.ListScrollFrame2;
	
	local offset = HybridScrollFrame_GetOffset(scrollFrame);
	local buttons = scrollFrame.buttons;
	local numList = 4;

	for i=1, #buttons do
		local button = buttons[i];
		local displayIndex = i + offset;
		if ( displayIndex <= numList ) then
			local index = displayIndex;
			button.buttonNumber = index;
			--button.FakeScroll.animIn.Translation:SetStartDelay(index/10)
			button.VirtualSwitch.animIn.Translation:SetStartDelay(index/10)
			button.Title:SetText(Shelf[index]["Title"]);
			button.DescriptionClipper.Description:SetText(Shelf[index]["Description"]);
			local textureFile = "Interface/AddOns/AzerothAdventureAlbum/Art/Animations/BookCover"..index;
			button.AnimCover:SetTexture(textureFile);
			button.StatusBar:SetColorTexture(Shelf[index]["BarColor"]["r"],Shelf[index]["BarColor"]["g"],Shelf[index]["BarColor"]["b"],0.6)
			UpdateShelfProgressBar(button);

			if (Shelf[index]["Status"]) then
				button.active = active;
				button:Show();
				button:SetEnabled(true);
			else
				button:Disable();
				button.AnimCover:SetDesaturated(true);
				button.Scroll:SetDesaturated(true);
				button.StatusBar:SetDesaturated(true);
				button.Title:SetTextColor(1,1,1);
			end
		else
			button:Hide();
			button:SetEnabled(false);
		end
	end
	local totalWidth = numList * buttons[1]:GetWidth();
	HybridScrollFrame_Update_Horizontal(scrollFrame, totalWidth, scrollFrame:GetWidth());
end

function AAAlbumMainFrameMixin:GoToCard(album, index)
	lastbuttonNumber = nil;
	CurrentAlbum = album;
	self.VirtualFrame:SetAlpha(1);
	Journal_UpdateList()
	local ExpectedValue = self.ListScrollFrame.buttons[1]:GetHeight()*(index - 1);
	self.ListScrollFrame.scrollBar:SetValue(ExpectedValue);
	local RealValue = self.ListScrollFrame.scrollBar:GetValue();
	if(math.floor(ExpectedValue + 0.5) == RealValue) then
		self.ListScrollFrame.buttons[1]:Click();
	else
		self.ListScrollFrame.buttons[7-(#CurrentAlbum-index)]:Click();	
	end
end

AAAlbumMinimapButtonMixin = {};

function AAAlbumMinimapButtonMixin:OnLoad()
	MinimapButton = self;	--Local

	self:RegisterForClicks("LeftButtonUp","RightButtonUp","MiddleButtonUp");
	self:RegisterForDrag("LeftButton","RightButton");

	self.UpdateFrame = CreateFrame("Frame", self);
	self.UpdateFrame:Hide();
	self.UpdateFrame:SetScript("OnUpdate", UpdateFrame_OnUpdate);
end

function AAAlbumMinimapButtonMixin:OnClick(button)
	GameTooltip:Hide()

	if button == "RightButton" and IsShiftKeyDown() then
		self:Hide();
		print(L["Minimap Disabled Notes"]);
		AAASettings["Minimap"] = false;
		UpdateMinimapSettings();
		return;
	end
	
	if button == "LeftButton" then
		OpenNClosePanel();
		self:Disable();
		C_Timer.After(0.8, function()
			self:Enable()
		end)
		return;
	end
end

function AAAlbumMinimapButtonMixin:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT",-20,-100);
	GameTooltip:SetText(L["AAA Gradient"], 1, 1, 1);
	GameTooltip:AddLine(L["Click To Open"], nil, nil, nil, true);
	GameTooltip:AddLine(L["Click To Hide"], nil, nil, nil, true);
	GameTooltip:Show()
	UIFrameFadeIn(self.ShadowGradient,0.15,0,0.6);
	UIFrameFadeIn(self.ColorGradient,0.15,0,1);
	self.ColorGradient.animIn:Play();
	SetCursor("Interface/CURSOR/Inspect.blp");
end

function AAAlbumMinimapButtonMixin:UpdateVisibility()
	if(AAASettings["Minimap"] ~= nil and AAASettings["Minimap"] == true) then
		self:Show();
	else
		self:Hide();
	end
end

function AAAlbumMinimapButtonMixin:OnLeave()
	ResetCursor();
	GameTooltip:Hide();
	self.ColorGradient.animIn:Pause();
	UIFrameFadeOut(self.ColorGradient,0.15,1,0);
	if not self.Color:IsShown() then
		UIFrameFadeOut(self.ShadowGradient,0.15,0.6,0);
	end
end

function AAAlbumMinimapButtonMixin:OnDragStart()
	self.UpdateFrame:Show();
end

function AAAlbumMinimapButtonMixin:OnDragStop()
	self.UpdateFrame:Hide();
end



AAAlbumSwitchMixin = {};

function AAAlbumSwitchMixin:OnLoad()
	AlbumSwitch = self;
	tinsert(UISpecialFrames, self:GetName());
end

function AAAlbumSwitchMixin:OnShow()
	--[[
	if ( (hour >=23 or hour <=5) and (minute >= 0) )then
		MENU_OPENSOUND = (82664); --Owl
	else
		MENU_OPENSOUND = (SOUNDKIT.ACHIEVEMENT_MENU_OPEN);
	end
	--]]

	EnableNightMode();
	SnowEffect(true)

	PlaySound(MENU_OPENSOUND, "Master");
	Blackscreen.Black:SetColorTexture(0,0,0,BlackscreenAlpha);
	UIFrameFadeIn(Blackscreen, 1, 0, 1)
	--determine whether intro page pops up or not. 
	--only pops up once for each login (see LoadProgress.lua)

	if (self:IsVisible()) then
		if (filterChoice == nil) then
			Journal_UpdateList();
		end
	end
	
	MinimapButton.Color:Show();
	MinimapButton.ShadowGradient:Show();
end

function AAAlbumSwitchMixin:OnHide()
	
	SnowEffect(false)
	UIFrameFadeOut(Blackscreen, 0.5, Blackscreen:GetAlpha(), 0)
	
	if NightMode:IsShown() then
		NightMode.animIn:Stop();
		NightMode.animOut:Play();
	end

	PlaySound(SOUNDKIT.ACHIEVEMENT_MENU_CLOSE);
	MainFrame.VirtualFrame.JournalTestBackground.animOut:Stop();
	MainFrame.Filter:Hide();
	MainFrame.Settings:Hide();
	MinimapButton.Color:Hide();
	MinimapButton.ShadowGradient:Hide();
	MainFrame.VirtualFrame.JournalDisplay.DisplayBottomLayer:Hide();
	MainFrame:HidePanel();
end


AAAlbumEntryButtonMixin = {};

function AAAlbumEntryButtonMixin:OnLoad()
	self:RegisterForClicks("LeftButtonUp","RightButtonUp");
end

function AAAlbumEntryButtonMixin:OnClick()
	MainFrame.Filter:Hide();
	MainFrame.Settings:Hide();

	local buttonNumber = self.entryID;
	if (buttonNumber ~= nil and buttonNumber ~= lastbuttonNumber) then
		lastbuttonNumber = buttonNumber;
		MainFrame.selectedID = buttonNumber;
		MainFrame.VirtualFrame.JournalTestBackground.Source:SetText(CurrentAlbum[buttonNumber]["Location"]);
		local OldTopLayerTeture = MainFrame.VirtualFrame.JournalDisplayTopLayer.Display:GetTexture();
		if (CurrentAlbum[buttonNumber]["Status"]) then
			MainFrame.VirtualFrame.JournalTestBackground.Lore:SetText(CurrentAlbum[buttonNumber]["Lore"]);
			MainFrame.VirtualFrame.JournalDisplayTopLayer.Display:SetTexture(CurrentAlbum[buttonNumber]["Image"]);
		else
			MainFrame.VirtualFrame.JournalTestBackground.Lore:SetText(L["Collect To Unlock"]);
			MainFrame.VirtualFrame.JournalDisplayTopLayer.Display:SetTexture(CurrentAlbum[buttonNumber]["Image-faded"]);
		end
		MainFrame.VirtualFrame.JournalDisplay.DisplayBottomLayer:SetTexture(OldTopLayerTeture)
		MainFrame.VirtualFrame.JournalDisplayTopLayer.animIn:Play();

		UpdatePaperHeight();
		local temp = MainFrame.ListScrollFrame.scrollBar:GetValue();
		MainFrame.ListScrollFrame.scrollBar:SetValue(72)
		MainFrame.ListScrollFrame.scrollBar:SetValue(temp)
		Journal_UpdateList();
	end
end

function AAAlbumEntryButtonMixin:OnEnter()
	if ( self.Description:IsTruncated() ) then
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR");
		GameTooltip:SetText(self.Description:GetText() , 1, 1, 1, 1, true);
		self.showingTooltip = true;
	end
end

function AAAlbumEntryButtonMixin:OnLeave()
	GameTooltip:Hide();
	self.showingTooltip = false;
end

local LoadSettings = CreateFrame("Frame");

LoadSettings:RegisterEvent("PLAYER_ENTERING_WORLD");

LoadSettings:SetScript("OnEvent",function(self,event,...)
	Blackscreen = AAAlbum_BlackScreen;
	MinimapButton_OnLoad();
	MinimapButton:UpdateVisibility();
	GetTotalProgress();
	MainFrame:UpdateShelf();
	UpdateSettings();
	LoadSettings:UnregisterEvent("PLAYER_ENTERING_WORLD");
end)
